<html>
<head>
<title>Ogre::Bitwise Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1Bitwise.html">Bitwise</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-static-methods">Static Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::Bitwise Class Reference<div class="ingroups"><a class="el" href="group__Math.html">Math</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::Bitwise" -->
<p>Class for manipulating bit patterns.  
 <a href="classOgre_1_1Bitwise.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreBitwise_8h_source.html">OgreBitwise.h</a>&gt;</code></p>

<p><a href="classOgre_1_1Bitwise-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="OgrePlatform_8h.html#a724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Bitwise.html#aa3fd3a659f416fe2f6e034c42b6a873c">mostSignificantBitSet</a> (unsigned int value)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the most significant bit set in a value.  <a href="#aa3fd3a659f416fe2f6e034c42b6a873c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="OgrePlatform_8h.html#a724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> <a class="el" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Bitwise.html#af1d86f2723f835a233138259c962a952">firstPO2From</a> (<a class="el" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> n)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the closest power-of-two number greater or equal to value.  <a href="#af1d86f2723f835a233138259c962a952"></a><br/></td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename T &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">static <a class="el" href="OgrePlatform_8h.html#a724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOgre_1_1Bitwise.html#acef0757b2a07e5b297c87247f38f1691">isPO2</a> (T n)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Determines whether the number is power-of-two or not.  <a href="#acef0757b2a07e5b297c87247f38f1691"></a><br/></td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename T &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">static <a class="el" href="OgrePlatform_8h.html#a724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> unsigned int&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOgre_1_1Bitwise.html#a60bde1c399a387326753a52f9d56939c">getBitShift</a> (T mask)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the number of bits a pattern must be shifted right by to remove right-hand zeros.  <a href="#a60bde1c399a387326753a52f9d56939c"></a><br/></td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename SrcT , typename DestT &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">static DestT&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOgre_1_1Bitwise.html#a65c7e2d0a2b2278e58450bb9d289e148">convertBitPattern</a> (SrcT srcValue, SrcT srcBitMask, DestT destBitMask)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Takes a value with a given src bit mask, and produces another value with a desired bit mask.  <a href="#a65c7e2d0a2b2278e58450bb9d289e148"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Bitwise.html#aa59b3726641c31b63aa3e203559ca3bd">fixedToFixed</a> (<a class="el" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> value, unsigned int n, unsigned int p)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert N bit colour channel value to P bits.  <a href="#aa59b3726641c31b63aa3e203559ca3bd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Bitwise.html#ad3f4d30ecc1aa5ea112a38e63a47b9c8">floatToFixed</a> (const float value, const unsigned int bits)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert floating point colour channel value between 0.0 and 1.0 (otherwise clamped) to integer of a certain number of bits.  <a href="#ad3f4d30ecc1aa5ea112a38e63a47b9c8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Bitwise.html#a48006ba79d6f8c690e3131c7b4e441bf">fixedToFloat</a> (unsigned value, unsigned int bits)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Fixed point to float.  <a href="#a48006ba79d6f8c690e3131c7b4e441bf"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Bitwise.html#afa88e9d32bbc468ac3ee803ee4228ca1">intWrite</a> (void *dest, const int n, const unsigned int value)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write a n*8 bits integer value to memory in native endian.  <a href="#afa88e9d32bbc468ac3ee803ee4228ca1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Bitwise.html#ad0fcaa2e4f445d1e9c1fb69291061dec">intRead</a> (const void *src, int n)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Read a n*8 bits integer value to memory in native endian.  <a href="#ad0fcaa2e4f445d1e9c1fb69291061dec"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Bitwise.html#aa02a9c5a117baf2da38ad562c2130681">floatToHalf</a> (float i)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert a float32 to a float16 (NV_half_float) Courtesy of OpenEXR.  <a href="#aa02a9c5a117baf2da38ad562c2130681"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Bitwise.html#ad98268f6e1288301c0471e345e98cd1e">floatToHalfI</a> (<a class="el" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> i)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Converts float in uint32 format to a a half in uint16 format.  <a href="#ad98268f6e1288301c0471e345e98cd1e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Bitwise.html#abb3cbaa74865420859ba7b1061f8d3f3">halfToFloat</a> (<a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> y)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert a float16 (NV_half_float) to a float32 Courtesy of OpenEXR.  <a href="#abb3cbaa74865420859ba7b1061f8d3f3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Bitwise.html#a7ccd62b11c082f76d4972e27896c6028">halfToFloatI</a> (<a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> y)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Converts a half in uint16 format to a float in uint32 format.  <a href="#a7ccd62b11c082f76d4972e27896c6028"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Class for manipulating bit patterns. </p>

<p>Definition at line <a class="el" href="OgreBitwise_8h_source.html#l00043">43</a> of file <a class="el" href="OgreBitwise_8h_source.html">OgreBitwise.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a65c7e2d0a2b2278e58450bb9d289e148"></a><!-- doxytag: member="Ogre::Bitwise::convertBitPattern" ref="a65c7e2d0a2b2278e58450bb9d289e148" args="(SrcT srcValue, SrcT srcBitMask, DestT destBitMask)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SrcT , typename DestT &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">static DestT <a class="el" href="classOgre_1_1Bitwise.html#a65c7e2d0a2b2278e58450bb9d289e148">Ogre::Bitwise::convertBitPattern</a> </td>
          <td>(</td>
          <td class="paramtype">SrcT&#160;</td>
          <td class="paramname"><em>srcValue</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">SrcT&#160;</td>
          <td class="paramname"><em>srcBitMask</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">DestT&#160;</td>
          <td class="paramname"><em>destBitMask</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Takes a value with a given src bit mask, and produces another value with a desired bit mask. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This routine is useful for colour conversion. </dd></dl>

<p>Definition at line <a class="el" href="OgreBitwise_8h_source.html#l00102">102</a> of file <a class="el" href="OgreBitwise_8h_source.html">OgreBitwise.h</a>.</p>

<p>References <a class="el" href="OgreBitwise_8h_source.html#l00083">getBitShift()</a>.</p>

</div>
</div>
<a class="anchor" id="af1d86f2723f835a233138259c962a952"></a><!-- doxytag: member="Ogre::Bitwise::firstPO2From" ref="af1d86f2723f835a233138259c962a952" args="(uint32 n)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="OgrePlatform_8h.html#a724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> <a class="el" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="el" href="classOgre_1_1Bitwise.html#af1d86f2723f835a233138259c962a952">Ogre::Bitwise::firstPO2From</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>&#160;</td>
          <td class="paramname"><em>n</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the closest power-of-two number greater or equal to value. </p>
<dl class="note"><dt><b>Note:</b></dt><dd>0 and 1 are powers of two, so firstPO2From(0)==0 and firstPO2From(1)==1. </dd></dl>

<p>Definition at line <a class="el" href="OgreBitwise_8h_source.html#l00060">60</a> of file <a class="el" href="OgreBitwise_8h_source.html">OgreBitwise.h</a>.</p>

</div>
</div>
<a class="anchor" id="aa59b3726641c31b63aa3e203559ca3bd"></a><!-- doxytag: member="Ogre::Bitwise::fixedToFixed" ref="aa59b3726641c31b63aa3e203559ca3bd" args="(uint32 value, unsigned int n, unsigned int p)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static unsigned int <a class="el" href="classOgre_1_1Bitwise.html#aa59b3726641c31b63aa3e203559ca3bd">Ogre::Bitwise::fixedToFixed</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>&#160;</td>
          <td class="paramname"><em>value</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>n</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>p</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Convert N bit colour channel value to P bits. </p>
<p>It fills P bits with the bit pattern repeated. (this is /((1&lt;&lt;n)-1) in fixed point) </p>

<p>Definition at line <a class="el" href="OgreBitwise_8h_source.html#l00127">127</a> of file <a class="el" href="OgreBitwise_8h_source.html">OgreBitwise.h</a>.</p>

</div>
</div>
<a class="anchor" id="a48006ba79d6f8c690e3131c7b4e441bf"></a><!-- doxytag: member="Ogre::Bitwise::fixedToFloat" ref="a48006ba79d6f8c690e3131c7b4e441bf" args="(unsigned value, unsigned int bits)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static float <a class="el" href="classOgre_1_1Bitwise.html#a48006ba79d6f8c690e3131c7b4e441bf">Ogre::Bitwise::fixedToFloat</a> </td>
          <td>(</td>
          <td class="paramtype">unsigned&#160;</td>
          <td class="paramname"><em>value</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>bits</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Fixed point to float. </p>

<p>Definition at line <a class="el" href="OgreBitwise_8h_source.html#l00161">161</a> of file <a class="el" href="OgreBitwise_8h_source.html">OgreBitwise.h</a>.</p>

</div>
</div>
<a class="anchor" id="ad3f4d30ecc1aa5ea112a38e63a47b9c8"></a><!-- doxytag: member="Ogre::Bitwise::floatToFixed" ref="ad3f4d30ecc1aa5ea112a38e63a47b9c8" args="(const float value, const unsigned int bits)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static unsigned int <a class="el" href="classOgre_1_1Bitwise.html#ad3f4d30ecc1aa5ea112a38e63a47b9c8">Ogre::Bitwise::floatToFixed</a> </td>
          <td>(</td>
          <td class="paramtype">const float&#160;</td>
          <td class="paramname"><em>value</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const unsigned int&#160;</td>
          <td class="paramname"><em>bits</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Convert floating point colour channel value between 0.0 and 1.0 (otherwise clamped) to integer of a certain number of bits. </p>
<p>Works for any value of bits between 0 and 31. </p>

<p>Definition at line <a class="el" href="OgreBitwise_8h_source.html#l00151">151</a> of file <a class="el" href="OgreBitwise_8h_source.html">OgreBitwise.h</a>.</p>

</div>
</div>
<a class="anchor" id="aa02a9c5a117baf2da38ad562c2130681"></a><!-- doxytag: member="Ogre::Bitwise::floatToHalf" ref="aa02a9c5a117baf2da38ad562c2130681" args="(float i)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="el" href="classOgre_1_1Bitwise.html#aa02a9c5a117baf2da38ad562c2130681">Ogre::Bitwise::floatToHalf</a> </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>i</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Convert a float32 to a float16 (NV_half_float) Courtesy of OpenEXR. </p>

<p>Definition at line <a class="el" href="OgreBitwise_8h_source.html#l00222">222</a> of file <a class="el" href="OgreBitwise_8h_source.html">OgreBitwise.h</a>.</p>

<p>References <a class="el" href="OgreBitwise_8h_source.html#l00230">floatToHalfI()</a>.</p>

</div>
</div>
<a class="anchor" id="ad98268f6e1288301c0471e345e98cd1e"></a><!-- doxytag: member="Ogre::Bitwise::floatToHalfI" ref="ad98268f6e1288301c0471e345e98cd1e" args="(uint32 i)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="el" href="classOgre_1_1Bitwise.html#ad98268f6e1288301c0471e345e98cd1e">Ogre::Bitwise::floatToHalfI</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>&#160;</td>
          <td class="paramname"><em>i</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Converts float in uint32 format to a a half in uint16 format. </p>

<p>Definition at line <a class="el" href="OgreBitwise_8h_source.html#l00230">230</a> of file <a class="el" href="OgreBitwise_8h_source.html">OgreBitwise.h</a>.</p>

<p>Referenced by <a class="el" href="OgreBitwise_8h_source.html#l00222">floatToHalf()</a>.</p>

</div>
</div>
<a class="anchor" id="a60bde1c399a387326753a52f9d56939c"></a><!-- doxytag: member="Ogre::Bitwise::getBitShift" ref="a60bde1c399a387326753a52f9d56939c" args="(T mask)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="OgrePlatform_8h.html#a724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> unsigned int <a class="el" href="classOgre_1_1Bitwise.html#a60bde1c399a387326753a52f9d56939c">Ogre::Bitwise::getBitShift</a> </td>
          <td>(</td>
          <td class="paramtype">T&#160;</td>
          <td class="paramname"><em>mask</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the number of bits a pattern must be shifted right by to remove right-hand zeros. </p>

<p>Definition at line <a class="el" href="OgreBitwise_8h_source.html#l00083">83</a> of file <a class="el" href="OgreBitwise_8h_source.html">OgreBitwise.h</a>.</p>

<p>Referenced by <a class="el" href="OgreBitwise_8h_source.html#l00102">convertBitPattern()</a>.</p>

</div>
</div>
<a class="anchor" id="abb3cbaa74865420859ba7b1061f8d3f3"></a><!-- doxytag: member="Ogre::Bitwise::halfToFloat" ref="abb3cbaa74865420859ba7b1061f8d3f3" args="(uint16 y)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static float <a class="el" href="classOgre_1_1Bitwise.html#abb3cbaa74865420859ba7b1061f8d3f3">Ogre::Bitwise::halfToFloat</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>&#160;</td>
          <td class="paramname"><em>y</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Convert a float16 (NV_half_float) to a float32 Courtesy of OpenEXR. </p>

<p>Definition at line <a class="el" href="OgreBitwise_8h_source.html#l00273">273</a> of file <a class="el" href="OgreBitwise_8h_source.html">OgreBitwise.h</a>.</p>

<p>References <a class="el" href="OgreBitwise_8h_source.html#l00282">halfToFloatI()</a>.</p>

</div>
</div>
<a class="anchor" id="a7ccd62b11c082f76d4972e27896c6028"></a><!-- doxytag: member="Ogre::Bitwise::halfToFloatI" ref="a7ccd62b11c082f76d4972e27896c6028" args="(uint16 y)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="el" href="classOgre_1_1Bitwise.html#a7ccd62b11c082f76d4972e27896c6028">Ogre::Bitwise::halfToFloatI</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>&#160;</td>
          <td class="paramname"><em>y</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Converts a half in uint16 format to a float in uint32 format. </p>

<p>Definition at line <a class="el" href="OgreBitwise_8h_source.html#l00282">282</a> of file <a class="el" href="OgreBitwise_8h_source.html">OgreBitwise.h</a>.</p>

<p>Referenced by <a class="el" href="OgreBitwise_8h_source.html#l00273">halfToFloat()</a>.</p>

</div>
</div>
<a class="anchor" id="ad0fcaa2e4f445d1e9c1fb69291061dec"></a><!-- doxytag: member="Ogre::Bitwise::intRead" ref="ad0fcaa2e4f445d1e9c1fb69291061dec" args="(const void *src, int n)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static unsigned int <a class="el" href="classOgre_1_1Bitwise.html#ad0fcaa2e4f445d1e9c1fb69291061dec">Ogre::Bitwise::intRead</a> </td>
          <td>(</td>
          <td class="paramtype">const void *&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>n</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Read a n*8 bits integer value to memory in native endian. </p>

<p>Definition at line <a class="el" href="OgreBitwise_8h_source.html#l00197">197</a> of file <a class="el" href="OgreBitwise_8h_source.html">OgreBitwise.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa88e9d32bbc468ac3ee803ee4228ca1"></a><!-- doxytag: member="Ogre::Bitwise::intWrite" ref="afa88e9d32bbc468ac3ee803ee4228ca1" args="(void *dest, const int n, const unsigned int value)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void <a class="el" href="classOgre_1_1Bitwise.html#afa88e9d32bbc468ac3ee803ee4228ca1">Ogre::Bitwise::intWrite</a> </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>dest</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const int&#160;</td>
          <td class="paramname"><em>n</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const unsigned int&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write a n*8 bits integer value to memory in native endian. </p>

<p>Definition at line <a class="el" href="OgreBitwise_8h_source.html#l00169">169</a> of file <a class="el" href="OgreBitwise_8h_source.html">OgreBitwise.h</a>.</p>

</div>
</div>
<a class="anchor" id="acef0757b2a07e5b297c87247f38f1691"></a><!-- doxytag: member="Ogre::Bitwise::isPO2" ref="acef0757b2a07e5b297c87247f38f1691" args="(T n)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="OgrePlatform_8h.html#a724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> bool <a class="el" href="classOgre_1_1Bitwise.html#acef0757b2a07e5b297c87247f38f1691">Ogre::Bitwise::isPO2</a> </td>
          <td>(</td>
          <td class="paramtype">T&#160;</td>
          <td class="paramname"><em>n</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Determines whether the number is power-of-two or not. </p>
<dl class="note"><dt><b>Note:</b></dt><dd>0 and 1 are tread as power of two. </dd></dl>

<p>Definition at line <a class="el" href="OgreBitwise_8h_source.html#l00075">75</a> of file <a class="el" href="OgreBitwise_8h_source.html">OgreBitwise.h</a>.</p>

</div>
</div>
<a class="anchor" id="aa3fd3a659f416fe2f6e034c42b6a873c"></a><!-- doxytag: member="Ogre::Bitwise::mostSignificantBitSet" ref="aa3fd3a659f416fe2f6e034c42b6a873c" args="(unsigned int value)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="OgrePlatform_8h.html#a724fb9f82013c782db5c3c12ea36aac8">FORCEINLINE</a> unsigned int <a class="el" href="classOgre_1_1Bitwise.html#aa3fd3a659f416fe2f6e034c42b6a873c">Ogre::Bitwise::mostSignificantBitSet</a> </td>
          <td>(</td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the most significant bit set in a value. </p>

<p>Definition at line <a class="el" href="OgreBitwise_8h_source.html#l00047">47</a> of file <a class="el" href="OgreBitwise_8h_source.html">OgreBitwise.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreBitwise_8h_source.html">OgreBitwise.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:54
</p>
</body>
</html>
